/**
 * @file fsd_debug.h
 * @brief Implements debugging macros for deamon part of filesystem.
 * @author Michal Podzimek, Michal Ficek, Tomas Pop, MFF UK, 2007
 *
 * @addtogroup q_mysqlfs_deamon MySQL FS Deamon
 * @{
 * @addtogroup g_mysqlfs_deamon_degub Debug
 * @{
 * 
 */


#ifndef FSD_DEBUG_H_
#define FSD_DEBUG_H_


/** If defined, debugging prints will be visible. */
#define FSD_DEBUG
/** If defined, info prints will be visible. */
#define FSD_INFO


/** Macro for write message to stderr. */
#undef PDEBUG /* undef it, just in case */
#ifdef FSD_DEBUG
#	define PDEBUG(fmt, args...) fprintf(stderr, "FSD: " fmt, ## args)
#else
#	define PDEBUG(fmt, args...) /* not debugging: nothing */
#endif


/** Macro for write message to stdout. */
#undef PINFO /* undef it, just in case */
#ifdef FSD_INFO
#	define PINFO(fmt, args...) printf(fmt, ## args)
#else
#	define PINFO(fmt, args...) /* not info: nothing */
#endif


#endif


/**
 *
 * @}
 * 
 * @}
 * 
 */
