/**
 * @file fsd_device.h
 * @brief Header file for implementation of device communication, file fsd_device.c
 * @author Michal Podzimek, Michal Ficek, Tomas Pop, MFF UK, 2007
 *
 * @addtogroup q_mysqlfs_deamon MySQL FS Deamon
 * @{
 * @addtogroup g_mysqlfs_deamon_device Device
 * @{
 * 
 * This file contents declaration of functions which provide connection to 
 * char device and communication with it.
 * 
 */

#ifndef _FSD_DEVICE_H_
#define _FSD_DEVICE_H_


#include <stdio.h>

/** @name declaration of functions for communication with char device
 * 
 * @{
 */
int fsd_chardevice_open();
int fsd_chardevice_close(int fsc_device);
int fsd_chardevice_read(int fsc_device, char *buffer);
int fsd_chardevice_write(int fsc_device, const char *buffer, int count);
/** @} */

#endif

/**
 *
 * @}
 * 
 * @}
 * 
 */
