
-- Vytvoreni noveho uzivatele "mysqlfs" s heslem "mysqlfs"

GRANT ALL PRIVILEGES ON * . * TO 'mysqlfs'@'localhost' IDENTIFIED BY 'mysqlfs' WITH GRANT OPTION MAX_QUERIES_PER_HOUR 0 MAX_CONNECTIONS_PER_HOUR 0 MAX_UPDATES_PER_HOUR 0 ;

-- 
-- Struktura tabulky `data`
-- 

CREATE TABLE `data` (
  `id` int(11) NOT NULL auto_increment,
  `file_id` int(11) NOT NULL,
  `data` blob NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `FK_data_file_id_files_id` (`file_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_czech_ci AUTO_INCREMENT=1 ;

-- 
-- Vypisuji data pro tabulku `data`
-- 


-- --------------------------------------------------------

-- 
-- Struktura tabulky `dirs`
-- 

CREATE TABLE `dirs` (
  `id` int(11) NOT NULL auto_increment,
  `parent_dir_id` int(11) default NULL,
  `name` varchar(64) collate utf8_czech_ci default NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `UN_dir_in_dir` (`parent_dir_id`,`name`),
  KEY `FK_dirs_parent_dir_id_dirs_id` (`parent_dir_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_czech_ci AUTO_INCREMENT=10001 ;

-- 
-- Vypisuji data pro tabulku `dirs`
-- 

INSERT INTO `dirs` VALUES (NULL, NULL, 'ROOT_DIRECTORY');

-- --------------------------------------------------------

-- 
-- Struktura tabulky `files`
-- 

CREATE TABLE `files` (
  `id` int(11) NOT NULL auto_increment,
  `parent_dir_id` int(11) default NULL,
  `name` varchar(64) collate utf8_czech_ci NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `UN_file_in_dir` (`parent_dir_id`,`name`),
  KEY `FK_files_parent_dir_id_dirs_id` (`parent_dir_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_czech_ci AUTO_INCREMENT=1 ;

-- 
-- Vypisuji data pro tabulku `files`
-- 


-- 
-- Omezení pro exportované tabulky
-- 

-- 
-- Omezení pro tabulku `data`
-- 
ALTER TABLE `data`
  ADD CONSTRAINT `FK_data_file_id_files_id` FOREIGN KEY (`file_id`) REFERENCES `files` (`id`) ON DELETE CASCADE;

-- 
-- Omezení pro tabulku `dirs`
-- 
ALTER TABLE `dirs`
  ADD CONSTRAINT `FK_dirs_parent_dir_id_dirs_id` FOREIGN KEY (`parent_dir_id`) REFERENCES `dirs` (`id`) ON DELETE CASCADE;

-- 
-- Omezení pro tabulku `files`
-- 
ALTER TABLE `files`
  ADD CONSTRAINT `FK_files_parent_dir_id_dirs_id` FOREIGN KEY (`parent_dir_id`) REFERENCES `dirs` (`id`) ON DELETE CASCADE;