#filesystem test.
# It works in these steps
# 1) create a file in some well-tested usual filesystem (ext2 or so)
# 2) copy this file to filesystem thet is tested
# 3) do tested operations with both the files
# 4) compare this two files

###### CONFIGURATION ############

#root directory of tested filesystem
FS_ROOT="/mnt/rkfs"   #"/tmp/fsroot"

#some temporar directory in well-tested filesystem
TMP_DIR="/tmp/fsroottmp"

#what do we want to test (you can switch off some tests here).
TESTED_OPERATIONS="write write_content cp cp_binary mkdir_rmdir mv"

#length of pseudo-random tested file in bytes default 5kB.. more then one block
FILE_LENGTH=5000

#filenames of created tested files and dirs
FILENAME="testfile"
DIR1=dir1;
DIR2=dir2;	
DIR3=dir_renamed;


#function definitions


# FIXME predelat aby byl obsah nahodny!!!
#generates a random - like file.
generate_file() {
	i=0
	mez=`expr $FILE_LENGTH / 10`
	while [ $i -lt $mez ]
	 do
	   echo -n "0123456789" >> "$TMP_DIR/$FILENAME"
	   i=`expr $i + 1`
	   #echo "..$i"
	 done
	return 0;
}


test_cp() {
	echo "Creating a file in tmp directory...";
	if  generate_file 
	 then 
	 echo "     [OK]";
	 else
	 echo "	    [FAILED]";
	 return 1; 
	fi

	echo "Trying to copy file to tested filesystem...";
	if  cp  "$TMP_DIR/$FILENAME" "$FS_ROOT/$FILENAME"
	 then 
	 echo "     [OK]";
	 else
	 echo "	    [FAILED]";
	 return 1; 
	fi

	ls -al "$FS_ROOT"
	echo ""

	echo "Performing diff operation on result files...";
	if  diff  "$TMP_DIR/$FILENAME" "$FS_ROOT/$FILENAME"
	 then 
	 echo "     [OK]";
	 else
	 echo "	    [FAILED]";
	 return 1; 
	fi

	rm "$TMP_DIR/$FILENAME";

	echo "Trying to copy file from tested filesystem...";
	if  cp  "$FS_ROOT/$FILENAME" "$TMP_DIR/$FILENAME" 
	 then 
	 echo "     [OK]";
	 else
	 echo "	    [FAILED]";
	 return 1; 
	fi

	echo "Performing diff operation on result files...";
	if  diff  "$TMP_DIR/$FILENAME" "$FS_ROOT/$FILENAME"
	 then 
	 echo "     [OK]";
	 else
	 echo "	    [FAILED]";
	 return 1; 
	fi

	rm "$TMP_DIR/$FILENAME";
	rm "$FS_ROOT/$FILENAME";

	return 0
}


test_write() {

	echo "Creating a file in tested fs root directory...";
	if  echo -n "" > "$FS_ROOT/$FILENAME"
	 then 
	 echo "     [OK]";
	 else
	 echo "	    [FAILED]";
	 return 1; 
	fi
	
	ls -al "$FS_ROOT"
	rm "$FS_ROOT/$FILENAME";
}

test_cp_binary() {
	echo "Creating a file in tmp directory...";
	if  generate_file 
	 then 
	 echo "     [OK]";
	 else
	 echo "	    [FAILED]";
	 return 1; 
	fi

	TESTFILE=test_archiv.tar.gz

	tar -czf "$TMP_DIR/$TESTFILE" "$TMP_DIR/$FILENAME"

	echo "Trying to copy file to tested filesystem...";
	if  cp  "$TMP_DIR/$TESTFILE" "$FS_ROOT/$TESTFILE"
	 then 
	 echo "     [OK]";
	 else
	 echo "	    [FAILED]";
	 return 1; 
	fi

	ls -al "$FS_ROOT"
	echo ""

	echo "Performing diff operation on result files...";
	if  diff  "$TMP_DIR/$TESTFILE" "$FS_ROOT/$TESTFILE"
	 then 
	 echo "     [OK]";
	 else
	 echo "	    [FAILED]";
	 return 1; 
	fi

	rm "$TMP_DIR/$TESTFILE";

	echo "Trying to copy file from tested filesystem...";
	if  cp  "$FS_ROOT/$TESTFILE" "$TMP_DIR/$TESTFILE" 
	 then 
	 echo "     [OK]";
	 else
	 echo "	    [FAILED]";
	 return 1; 
	fi

	echo "Performing diff operation on result files...";
	if  diff  "$TMP_DIR/$TESTFILE" "$FS_ROOT/$TESTFILE"
	 then 
	 echo "     [OK]";
	 else
	 echo "	    [FAILED]";
	 return 1; 
	fi

	rm "$TMP_DIR/$TESTFILE";
	rm "$FS_ROOT/$TESTFILE";

	return 0
}

test_write_content() {

	echo "Creating a file in tested fs root directory...";
	if  echo "Test message: 12345" > "$FS_ROOT/$FILENAME"
	 then 
	 echo "     [OK]";
	 else
	 echo "	    [FAILED]";
	 return 1; 
	fi
	
	ls -al "$FS_ROOT"
	echo ""
	cat "$FS_ROOT/$FILENAME"
	rm "$FS_ROOT/$FILENAME";
}

test_mkdir_rmdir() {
	(
	echo "Creating dir in root directory...";
	if  mkdir  "$FS_ROOT/$DIR1"
	 then 
	 echo "     [OK]";
	 else
	 echo "	    [FAILED]";
	 return 1; 
	fi

	ls -al "$FS_ROOT"
	echo ""
	
	echo "Entering created directory $FS_ROOT/$DIR1";
	if  cd  "$FS_ROOT/$DIR1"
	 then 
	 echo "     [OK]";
	 else
	 echo "	    [FAILED]";
	 return 1; 
	fi

	echo "Creating dir in directory $FS_ROOT/$DIR2...";
	# bacha, uz v tom adresari jsme
	if  mkdir  "$DIR2"
	 then 
	 echo "     [OK]";
	 else
	 echo "	    [FAILED]";
	 return 1; 
	fi

	ls -al "$FS_ROOT/$DIR1"
	echo ""

	echo "Entering created directory $FS_ROOT/$DIR1/$DIR2...";
	if  cd  "$FS_ROOT/$DIR1/$DIR2"
	 then 
	 echo "     [OK]";
	 else
	 echo "	    [FAILED]";
	 return 1; 
	fi

	echo "Removing created directories...";
	# konec exekuce v jednom shellu
	)
	echo "Subsubdirectory...";
	if rm -r "$FS_ROOT/$DIR1/$DIR2"
 	 then 
	 echo "     [OK]";
	 else
	 echo "	    [FAILED]";
	 return 1; 
	fi

	echo "Subdirectory...";
	if rm -r "$FS_ROOT/$DIR1"
 	 then 
	 echo "     [OK]";
	 else
	 echo "	    [FAILED]";
	 return 1; 
	fi


	return 0
}

test_mv() {

	(

	echo "Creating dir in root directory...";
	if  mkdir  "$FS_ROOT/$DIR1"
	 then 
	 echo "     [OK]";
	 else
	 echo "	    [FAILED]";
	 return 1; 
	fi

	ls -al "$FS_ROOT"
	echo "";

	echo "Creating dir in root directory...";
	if  mkdir  "$FS_ROOT/$DIR2"
	 then 
	 echo "     [OK]";
	 else
	 echo "	    [FAILED]";
	 return 1; 
	fi

	ls -al "$FS_ROOT"
	echo "";

	echo "Moving $FS_ROOT/$DIR2 into $FS_ROOT/$DIR1 ...";
	if  mv "$FS_ROOT/$DIR2" "$FS_ROOT/$DIR1"
	 then 
	 echo "     [OK]";
	 else
	 echo "	    [FAILED]";
	 return 1; 
	fi

	echo "See the result in $FS_ROOT/$DIR1..."
	ls -al "$FS_ROOT/$DIR1"
	echo "";

	echo "Renaming $FS_ROOT/$DIR1 to $FS_ROOT/$DIR3 ...";
	if  mv "$FS_ROOT/$DIR1" "$FS_ROOT/$DIR3"
	 then 
	 echo "     [OK]";
	 else
	 echo "	    [FAILED]";
	 return 1; 
	fi

	ls -al "$FS_ROOT"
	echo "";

	echo "Removing created directories...";
	# konec exekuce v jednom shellu
	)
	echo "Subsubdirectory...";
	if rm -r "$FS_ROOT/$DIR3"
 	 then 
	 echo "     [OK]";
	 else
	 echo "	    [FAILED]";
	 return 1; 
	fi

	return 0
}

OK=1

if [ ! -d "$FS_ROOT" ]
 then
 echo "Root directory is not possible to see like a directory." 
 echo -e "===========\nTEST FAILED\n===========";
 return 1
fi

if [ ! -d "$TMP_DIR" ]
 then
 echo "Tmp directory is not possible to see like a directory." 
 echo -e "===========\nTEST FAILED\n===========";
 return 1
fi


#main test loop
for operation in $TESTED_OPERATIONS; do
	echo -e "\n\n\nXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX"
	echo -e "Testing operation $operation"
	echo -e "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX\n"

		if eval "test_$operation"
		 then
		  echo -e "===========\nTEST PASSED\n===========";
		 else
		  echo -e "===========\nTEST FAILED\n===========";
		  OK=0
		fi
		  echo -en "Press enter to continue...";
		  read;
done

#	case  $operation in  
#	"write" )
#		echo "----------------------------------------- ----------------"
#		echo "-----------testing operation '$operation' ----------------"
#		echo "----------------------------------------- ----------------"
#		if eval "test_write"
#		 then
#		  echo -e "===========\nTEST PASSED\n===========";
#		 else
#		  echo -e "===========\nTEST FAILED\n===========";
#		  OK=0
#		fi
#	;;
#	
#
#	"mkdir" )
#		echo "----------------------------------------- ----------------"
#		echo "-----------testing operation '$operation' ----------------"
#		echo "----------------------------------------- ----------------"
#		if test_mkdir
#		 then
#		  echo -e "===========\nTEST PASSED\n===========";
#		 else
#		  echo -e "===========\nTEST FAILED\n===========";
#		  OK=0
#		fi
#	;;
#	esac





if [ 1 -eq $OK ]
 then
 echo "~~~~~~~~~ FINAL: ALL TESTS PASSED ~~~~~~~~~";
 exit 0
 else
 echo "~~~~~~~~~ FINAL: AT LEAST ONE TEST FAILED ~~~~~~~~~";
 exit 1
fi
#end of the script
