#!/bin/sh
module="rkfs"
device="fsc_dev"
group="users"
mode="664"

if ! /sbin/insmod ${module}.ko
 then
 echo "Insmod failed..."
 exit 1
fi

major=`cat /proc/devices | awk "\\$2==\"$device\" {print \\$1}"`

if ! rm -f /dev/$device
 then
 echo "can not remove device..."
 exit 1
fi

if ! mknod /dev/$device c $major 0
 then
 echo "can not execute mknod..."
 exit 1
fi

if ! chgrp $group /dev/${device}
 then
 echo "can not execute mknod..."
 exit 1
fi

if ! chmod $mode  /dev/${device}
 then
 echo "can not execute mknod..."
 exit 1
fi

#echo "SUCCESFULLY LOADED.";
exit 0