<?php

/**
 * @file mysqlfs.php
 * common functions used to show and manipulate files thrue php frontend for  mysqlfs
 * @author Tomas Pop
 */



/**
 * Add a file present in filesystem on server where mysql database engine is running to mysql database...
 *
 * @param int $dir_id id of 
 * @param string $file_name relative or absolute path to file present in filesystem of machine, where 
 * mysql server is running.
 * @param databaseobject $db database object 
 * @param string $file_store_as_name name of file we want to store file in fs  
 * @return array(bool, err_text)bool {true on succes or false on some problem}
 * 								err_text is textual description of some error if occures or null on no error
 */

function mysqlfs_add_file ($dir_id, $file_name, $file_store_as_name, $db){
	global $LANGUAGE;
	global $CHUNK_SIZE;
	//check whenewer some file with such name is already in dir
	$query = "select count(*) from (
			 	select 
					dirs.id as dir_id, 
					dirs.name as dir_name,
					dirs.parent_dir_id as dir_parrent_dir_id,
					files.name as file_name,
					files.id as file_id from
				dirs join files on files.parent_dir_id = dirs.id ) as file_dir 
				where file_name = '$file_store_as_name' and dir_id = $dir_id";

	$db->Query($query);
	$file_already_exists = $db->GetFirstRelation($query);
	if ($file_already_exists) {
		return array('bool'=>false, 'err_text'=>$LANGUAGE['FILE_ALREADY_EXISTS']);
	}
	
	$query = "INSERT INTO files (name, parent_dir_id) values ( '$file_store_as_name','$dir_id')";
	
	$db->Query($query);
	// file name is in db, now insert data.
	$file_id = $db->GetLastId();
	
	//echo $file_name;
	
	
	if (!($fd = fopen ($file_name, "r") )) echo "neotevrel jsem soubor";
	while ($chunk = addslashes(fread ($fd, $CHUNK_SIZE))){
			//echo "xxxxx";
			$query = "INSERT INTO data (file_id, data) values ('$file_id', '$chunk')";
			//echo "xxxx<br>".$query;
			$db->Query($query);
	}
	fclose ($fd);
	// now, filedata is in db.
	return array('bool'=>true, 'err_text'=>'');
};


function mysqlfs_show_dir_tree($dir_id) {
	global $db;
	global $LANGUAGE;


	//print name and basic information about a directory
	$query = "select * from dirs where id = $dir_id ";
	
	$db->Query($query);
	$dir_info = $db->GetFetchAssoc();
	echo "<br><div>".$dir_info['name']." [ directory, id = ".$dir_info['id']."]"."
				<span style='font-size:14px;'>
					[<a href='?action=delete_dir&amp;id=".$dir_info['id']."'>".$LANGUAGE['DELETE']."</a>]
					[".$LANGUAGE['ADD_FILE_TO_THIS_DIR']."<form style='display:inline;' enctype='multipart/form-data' action='?action=add_file&amp;id=".$dir_info['id']."' method='post'>"."<input type='file' name='file'><input type='hidden' name='dir_id' value='".$dir_info['id']."'><input type='submit' value='".$LANGUAGE['ADD_FILE_TO_THIS_DIR']."'></form>]
					[".$LANGUAGE['ADD_DIR_TO_THIS_DIR']."<form style='display:inline;' action='?action=add_dir&amp;id=".$dir_info['id']."' method='post'>"."<input type='text' name='new_dir_name'><input type='hidden' name='parent_dir_id' value='".$dir_info['id']."'><input type='submit' value='".$LANGUAGE['ADD_DIR_TO_THIS_DIR']."'></form>]
				</span></div>\n";
		echo "<div style='width:auto;border-left:1px solid gray;border-bottom:1px solid gray;padding-left:20px;'>\n";	
	//print files in direcrory
	$query = "select * from files where parent_dir_id = $dir_id "; 
	$db->Query($query);
	while ($resarr = $db->GetFetchAssoc()){
		echo "	<div>
					".$resarr['name']." [file, id = ".$resarr['id']."]
					[<a href='?action=download_file&amp;id=".$resarr['id']."'>".$LANGUAGE["DOWNLOAD"]."</a>]
					[<a href='?action=delete_file&amp;id=".$resarr['id']."'>".$LANGUAGE['DELETE']."</a>]
				</div>\n";
	}
	//print recursively all subdirectories
	$query = "select * from dirs where parent_dir_id = $dir_id "; 
	$res = $db->Query($query);
	while ($resarr = $db->GetFetchAssoc($res)){
		if ($dir_info['id'] != $resarr['id']) {
			mysqlfs_show_dir_tree($resarr['id']);
		}
		echo "&nbsp;";
	}
	echo "</div>\n";
}

function mysqlfs_show_fs_tree(){
	global $ROOT_DIRECTORY_ID;
	mysqlfs_show_dir_tree($ROOT_DIRECTORY_ID);
}

function mysqlfs_show_form_add_file ($action,$dir_id){
	echo ''.
	'<br><br><table border="0"><form action="'.$action.'" method="post" enctype="multipart/form-data">
		<td class="reg">File</td>
		<td><div class="cv_file"></div></td>
		<td><input type="file" name="file"></td>
		<td><input type="hidden" name="form_send" value="1">
			<input type="hidden" name="dir_id" value="'.$dir_id.'">
			<input type="submit" name="submit" value="OK">
		</td>
	</form></table><br><br>'."\n";
}



function get_arr_index($arr, $index) {
	if (array_key_exists($index,$arr)){
		return $arr[$index];
	}
	else {
		return null;
	}
}

function common_translate_national_chars($str){
global $LANGUAGE;
  return strtr($str, $LANGUAGE["LANGUAGE_NATIONALS_NATIONAL"]);
}

function mysqlfs_get_file($file_id){
	global $db;
	global $LANGUAGE;
	global $CHUNK_SIZE;
	
	
	$file_exists1 = $db->GetFirstRelation("select count(*) from files where id = $file_id");
	if (!$file_exists1) {
		return array('bool'=>false, 'err_text'=>$LANGUAGE['NO_SUCH_FILE']);
	}
	
	$file_exists2 = $db->GetFirstRelation("select count(*) from data where file_id = $file_id");
	if (!$file_exists2) {
		return array('bool'=>false, 'err_text'=>$LANGUAGE['ZERO_FILE_LENGTH']);
	}
	
	
	
	//so everthing OK.
	$query = "select * from files where id = $file_id ";
	$db->Query($query);
	$file_info  = $db->GetFetchAssoc();
	
	if (ereg('Opera(/| )([0-9].[0-9]{1,2})', $_SERVER['HTTP_USER_AGENT']))
  		$UserBrowser = "Opera";
 	elseif (ereg('MSIE ([0-9].[0-9]{1,2})', $_SERVER['HTTP_USER_AGENT']))
  		$UserBrowser = "IE";
 	else
  		$UserBrowser = '';
 	$mime_type = ($UserBrowser == 'IE' || $UserBrowser == 'Opera') ? 
  	'application/octetstream' : 'application/octet-stream';
 	header('Content-Type: ' . $mime_type);
 	header('Content-Disposition: attachment; filename="'.$file_info['name'].'"');
 	header('Accept-Ranges: bytes');
 	header("Cache-control: private");
 	header('Pragma: private');				
 	header("Content-Length: ".($file_exists2. $CHUNK_SIZE));
 
	$query = "select * from data where file_id = $file_id";
	$db->Query($query);
	while ($resarr = $db->GetFetchAssoc()){
		echo $resarr['data'];		
	}
	header("Connection: close");
	return array('bool'=>true, 'err_text'=>'');
}

function mysqlfs_add_dir($parent_dir_id, $new_dir_name) {
	global $db;
	global $LANGUAGE;
	echo $parent_dir_id;
	$parent_dir_exists = $db->GetFirstRelation("select count(*) from dirs where id = $parent_dir_id");
	if (!$parent_dir_exists) {
		return array('bool'=>false, 'err_text'=>$LANGUAGE['NO_SUCH_DIR']);
	}
	
	$query = "INSERT INTO dirs (name, parent_dir_id) values ('$new_dir_name', $parent_dir_id)";
	$db->Query($query);
	return array('bool'=>true, 'err_text'=>'');
}

function mysqlfs_delete_dir($dir_id) {
	global $db;
	global $LANGUAGE;
	
	$query = "DELETE FROM  dirs where id = $dir_id";
	$db->Query($query);
	return array('bool'=>true, 'err_text'=>'');
}

function mysqlfs_delete_file($file_id) {
	global $db;
	global $LANGUAGE;
	
	$query = "DELETE FROM  files where id = $file_id";
	$db->Query($query);
	return array('bool'=>true, 'err_text'=>'');
}



?>